Index: orxonox/trunk/configure
===================================================================
--- orxonox/trunk/configure	(revision 2967)
+++ orxonox/trunk/configure	(revision 2968)
@@ -3758,5 +3758,5 @@
 	#done before loop
 
-# checking gl header (has to be here because of a Linux error)
+# checking gl header
    # On IRIX 5.3, sys/types and inttypes.h are conflicting.
 
@@ -4664,5 +4664,5 @@
  Linux="yes"
 
-# checking gl header (has to be here because of a Linux error)
+# checking gl header
 
 for ac_header in GL/gl.h
@@ -5355,16 +5355,5 @@
      fi
 
-    ;;
-  *)
-    mingw="no"
-    ;;
-esac
-echo "$as_me:$LINENO: result: $mingw" >&5
-echo "${ECHO_T}$mingw" >&6
-
-
-#### Checking for LIBraries.
-
-# FIXME: Replace `main' with a function in `-lOSMesa':
+     # FIXME: Replace `main' with a function in `-lOSMesa':
 
 echo "$as_me:$LINENO: checking for main in -lOSMesa" >&5
@@ -5435,5 +5424,5 @@
 fi
 
-# FIXME: Replace `main' with a function in `-lX11':
+     # FIXME: Replace `main' with a function in `-lX11':
 
 echo "$as_me:$LINENO: checking for main in -lX11" >&5
@@ -5504,5 +5493,5 @@
 fi
 
-# FIXME: Replace `main' with a function in `-lXt':
+     # FIXME: Replace `main' with a function in `-lXt':
 
 echo "$as_me:$LINENO: checking for main in -lXt" >&5
@@ -5573,8 +5562,16 @@
 fi
 
+    ;;
+  *)
+    mingw="no"
+    ;;
+esac
+
+
+
 
 
 #checking for pthread libs
-echo "$as_me:$LINENO: checking for main in -lpthread" >&5
+ echo "$as_me:$LINENO: checking for main in -lpthread" >&5
 echo $ECHO_N "checking for main in -lpthread... $ECHO_C" >&6
 if test "${ac_cv_lib_pthread_main+set}" = set; then
@@ -5638,7 +5635,7 @@
 fi
 
-if test "$FOUND_pthread" = "yes" ; then
+ if test "$FOUND_pthread" = "yes" ; then
     LIBS="$LIBS -lpthread"
-fi
+ fi
 
 
Index: orxonox/trunk/configure.ac
===================================================================
--- orxonox/trunk/configure.ac	(revision 2967)
+++ orxonox/trunk/configure.ac	(revision 2968)
@@ -150,4 +150,10 @@
      fi   
 	
+     # FIXME: Replace `main' with a function in `-lOSMesa':
+      AC_CHECK_LIB([OSMesa], [main])
+     # FIXME: Replace `main' with a function in `-lX11':
+      AC_CHECK_LIB([X11], [main])
+     # FIXME: Replace `main' with a function in `-lXt':
+      AC_CHECK_LIB([Xt], [main])
     ;;
   *)
@@ -155,22 +161,14 @@
     ;;
 esac
-AC_MSG_RESULT([$mingw])
+
 AC_SUBST(MSBITFIELDS)
 
-#### Checking for LIBraries.
-
-# FIXME: Replace `main' with a function in `-lOSMesa':
-AC_CHECK_LIB([OSMesa], [main])
-# FIXME: Replace `main' with a function in `-lX11':
-AC_CHECK_LIB([X11], [main])
-# FIXME: Replace `main' with a function in `-lXt':
-AC_CHECK_LIB([Xt], [main])
 
 
 #checking for pthread libs
-AC_CHECK_LIB([pthread], [main], FOUND_pthread=yes)
-if test "$FOUND_pthread" = "yes" ; then
+ AC_CHECK_LIB([pthread], [main], FOUND_pthread=yes)
+ if test "$FOUND_pthread" = "yes" ; then
     LIBS="$LIBS -lpthread"
-fi
+ fi
 
 
@@ -178,5 +176,5 @@
 
 # FIXME: Replace `main' with a function in `-lm':
-AC_CHECK_LIB([m], [main])
+ AC_CHECK_LIB([m], [main])
 
 LIBS="$LIBS `pkg-config --libs  gtk+-2.0`"
Index: orxonox/trunk/importer/framework.cc
===================================================================
--- orxonox/trunk/importer/framework.cc	(revision 2967)
+++ orxonox/trunk/importer/framework.cc	(revision 2968)
@@ -128,5 +128,5 @@
 	      {
 		rotAxis.normalize();
-		printf ("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z, rotAngle);
+		//		printf ("rotAxis: %f, %f, %f\n", rotAxis.x, rotAxis.y, rotAxis.z, rotAngle);
 				
 		rotAngle = angle_rad (p1, p2);
Index: orxonox/trunk/src/player.cc
===================================================================
--- orxonox/trunk/src/player.cc	(revision 2967)
+++ orxonox/trunk/src/player.cc	(revision 2968)
@@ -26,5 +26,5 @@
 {
 
-  obj = new Object ("reaphigh.obj");
+  obj = new Object ("eagle.obj");
   /*
   objectList = glGenLists(1);
@@ -108,5 +108,5 @@
   
   glMatrixMode (GL_MODELVIEW);
-  glRotatef (-90, 0,1,0);
+  //  glRotatef (-90, 0,1,0);
   obj->draw();
   //  glCallList (objectList);